zoukankan      html  css  js  c++  java
  • 【Codeforces666E】Forensic Examination 后缀自动机 + 线段树合并

    E. Forensic Examination

    time limit per test:6 seconds
    memory limit per test:768 megabytes
    input:standard input
    output:standard output

    The country of Reberland is the archenemy of Berland. Recently the authorities of Berland arrested a Reberlandian spy who tried to bring the leaflets intended for agitational propaganda to Berland illegally . The most leaflets contain substrings of the Absolutely Inadmissible Swearword and maybe even the whole word.

    Berland legal system uses the difficult algorithm in order to determine the guilt of the spy. The main part of this algorithm is the following procedure.

    All the m leaflets that are brought by the spy are numbered from 1 to m. After that it's needed to get the answer to q queries of the following kind: "In which leaflet in the segment of numbers [l, r] the substring of the Absolutely Inadmissible Swearword [pl, pr] occurs more often?".

    The expert wants you to automate that procedure because this time texts of leaflets are too long. Help him!

    Input

    The first line contains the string s (1 ≤ |s| ≤ 5·105) — the Absolutely Inadmissible Swearword. The string s consists of only lowercase English letters.

    The second line contains the only integer m (1 ≤ m ≤ 5·104) — the number of texts of leaflets for expertise.

    Each of the next m lines contains the only string ti — the text of the i-th leaflet. The sum of lengths of all leaflet texts doesn't exceed 5·104. The text of the leaflets consists of only lowercase English letters.

    The next line contains integer q (1 ≤ q ≤ 5·105) — the number of queries for expertise.

    Finally, each of the last q lines contains four integers lrplpr (1 ≤ l ≤ r ≤ m, 1 ≤ pl ≤ pr ≤ |s|), where |s| is the length of the Absolutely Inadmissible Swearword.

    Output

    Print q lines. The i-th of them should contain two integers — the number of the text with the most occurences and the number of occurences of the substring [pl, pr] of the string s. If there are several text numbers print the smallest one.

    Examples
    input
    suffixtree
    3
    suffixtreesareawesome
    cartesiantreeisworsethansegmenttree
    nyeeheeheee
    2
    1 2 1 10
    1 3 9 10
    output
    1 1
    3 4

    Solution

    题目大意:给出一个模板串S和M个特殊串,每次询问S的[l,r]这个子串出现在编号为[pl,pr]的特殊串中最多出现次数以及其编号。

    显然可以把所有串连起来建后缀自动机。

    对于每个特殊串的节点,可以认为它包含一种颜色,然后查询操作实际上就是查询一个子树颜色数。

    这个可以从叶子节点利用线段树合并得到;

    总的复杂度是$O(NlogN)$

    Code

    #include<iostream>
    #include<cstdio>
    #include<cmath>
    #include<algorithm>
    #include<cstring>
    using namespace std;
    inline int read()
    {
    	int x=0,f=1; char ch=getchar();
    	while (ch<'0' || ch>'9') {if (ch=='-') f=-1; ch=getchar();}
    	while (ch>='0' && ch<='9') {x=x*10+ch-'0'; ch=getchar();}
    	return x*f;
    }
    
    #define MAXN 500010
    #define MAXS 1230010
    
    int N,M,Q,pos[MAXN];
    
    char S[MAXN],s[MAXN];
    
    int root=1,sz=1,last=1,par[MAXS],son[MAXS][27],len[MAXS],st[MAXS],id[MAXS];
    inline void Extend(int c)
    {
    	int cur=++sz,p=last;
    	len[cur]=len[p]+1;
    	while (p && !son[p][c]) son[p][c]=cur,p=par[p];
    	if (!p) par[cur]=root;
    	else {
    		int q=son[p][c];
    		if (len[p]+1==len[q]) par[cur]=q;
    		else {
    			int nq=++sz;
    			memcpy(son[nq],son[q],sizeof(son[nq]));
    			len[nq]=len[p]+1; par[nq]=par[q];
    			while (p && son[p][c]==q) son[p][c]=nq,p=par[p];
    			par[q]=par[cur]=nq;
    		}
    	}
    	last=cur;
    }
    
    inline void Sort()
    {
    	for (int i=0; i<=sz; i++) st[i]=0;
    	for (int i=1; i<=sz; i++) st[len[i]]++;
    	for (int i=0; i<=sz; i++) st[i]+=st[i-1];
    	for (int i=1; i<=sz; i++) id[st[len[i]]--]=i;
    }
    
    #define Pa pair<int,int>
    #define MP make_pair
    #define Max first
    #define Id second
    
    struct SgtNode{
    	Pa key;
    	int lson,rson;
    }tree[MAXS*23];
    
    inline Pa operator * (const Pa & A,const Pa &B) {return A.Max==B.Max? (A.Id<B.Id? A:B):(A.Max>B.Max? A:B);}
    
    inline Pa operator + (const Pa & A,const Pa &B) {return MP(A.Max+B.Max,A.Id);}
    
    int cnt,roots[MAXS],father[21][MAXS];
    inline void Insert(int &x,int val,int l,int r)
    {
    	if(!x) x=++cnt;
    	if (l==r) {tree[x].key.Max++,tree[x].key.Id=l; return;}
    	int mid=(l+r)>>1;
    	if (val<=mid) Insert(tree[x].lson,val,l,mid);
    		else Insert(tree[x].rson,val,mid+1,r);
    	tree[x].key=tree[tree[x].lson].key * tree[tree[x].rson].key;
    }
    
    inline int Merge(int x,int y,int l,int r)
    {
    	if (!x || !y) return x|y;
    	int z=++cnt;
    	if (l==r) {
    		tree[z].key=tree[x].key+tree[y].key;
    		return z;
    	}
    	int mid=(l+r)>>1;
    	tree[z].lson=Merge(tree[x].lson,tree[y].lson,l,mid);
    	tree[z].rson=Merge(tree[x].rson,tree[y].rson,mid+1,r);
    	tree[z].key=tree[tree[z].lson].key * tree[tree[z].rson].key;
    	return z;
    }
    
    inline Pa Query(int x,int l,int r,int L,int R)
    {
    	if (!x) return MP(0,0);
    	if (L<=l && R>=r) return tree[x].key;
    	int mid=(l+r)>>1;
    	if (R<=mid) return Query(tree[x].lson,l,mid,L,R);
    	else if (L>mid) return Query(tree[x].rson,mid+1,r,L,R);
    	else return Query(tree[x].lson,l,mid,L,mid) * Query(tree[x].rson,mid+1,r,mid+1,R);
    }
    
    inline int Get(int l,int r)
    {
    	int Len=r-l+1,x=pos[r];
    	for (int i=20; i>=0; i--) 
    		if (len[father[i][x]]>=Len)
    			x=father[i][x];
    	return x;
    }
    
    int main()
    {
    	scanf("%s",S+1); N=strlen(S+1);
    	for (int i=1; i<=N; i++) Extend(S[i]-'a'),pos[i]=last;
    	Extend(26);
    	M=read();
    	for (int j=1; j<=M; j++) {
    		scanf("%s",s+1); int le=strlen(s+1);
    		for (int i=1; i<=le; i++) {
    			Extend(s[i]-'a'),Insert(roots[last],j,1,M);
    		}
    		Extend(26);
    	}
    	
    	Sort();
    	
    	for (int i=sz; i>=1; i--) {
    		int x=id[i];
    		if (par[x]) roots[par[x]]=Merge(roots[par[x]],roots[x],1,M);
    	}
    	
    	for (int i=1; i<=sz; i++) father[0][i]=par[i];
    	
    	for (int j=1; j<=20; j++)
    		for (int i=1; i<=sz; i++)
    			father[j][i]=father[j-1][father[j-1][i]];
    	
    	Q=read();
    	while (Q--) {
    		int l=read(),r=read(),pl=read(),pr=read();
    		int x=Get(pl,pr);
    		Pa ans=Query(roots[x],1,M,l,r);
    		if (!ans.Max) printf("%d %d
    ",l,0);
    		else printf("%d %d
    ",ans.Id,ans.Max);
    	}
    	
    	return 0;
    }
    

      

  • 相关阅读:
    CocoStudio基础教程(4)骨骼动画的动态换肤
    CocoStudio基础教程(3)在程序中处理cocoStudio导出动画
    CocoStudio基础教程(2)关联程序逻辑与cocoStudio导出文件
    CocoStudio基础教程(1)创建UI并载入到程序中
    LeetCode:盛最多水的容器【11】
    LeetCode:反转字符串中的元音字母【345】
    LeetCode:验证回文串【125】
    LeetCode:颜色分类【75】
    LeetCode:删除排序数组中的重复项||【80】
    LeetCode:移动零【283】
  • 原文地址:https://www.cnblogs.com/DaD3zZ-Beyonder/p/6425906.html
Copyright © 2011-2022 走看看